package Client;

import Client.*;
import CampusInfo.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import javax.swing.UIManager;
import java.awt.*;

public class UniClient
{
    private static String [] parameter;
    private static ORB orb;
    private static org.omg.CORBA.Object objRef;
    private static NamingContextExt ncRef;

    public static UniCommerce uniCommerceImpl;

    private boolean packFrame = false;
    private ClientFrame frame;
    private Controller controller;

    //Construct the application
    public UniClient()
    {
        controller = new Controller(this);
        frame = new ClientFrame(controller);
        controller.setMainFrame(frame);

        //Validate frames that have preset sizes
        //Pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame){frame.pack();}
        else{frame.validate();}

        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height){frameSize.height = screenSize.height;}
        if (frameSize.width > screenSize.width){frameSize.width = screenSize.width;}
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.updateView();
        frame.setVisible(true);

        initORB();
        initUniCommerce();
    }

    private void initORB()
    {
        try
        {
            orb = ORB.init(parameter, null);
            objRef =orb.resolve_initial_references("NameService");
            ncRef = NamingContextExtHelper.narrow(objRef);
        }
        catch(Exception ex)
        {
            System.out.println("ERROR: Connect to ORB failed");
            ex.printStackTrace(System.out);
        }


    }

    private void initUniCommerce()
    {
        try
        {
            String name = "UniCommerce";
            uniCommerceImpl = UniCommerceHelper.narrow(ncRef.resolve_str(name));
        }

        catch (Exception ex)
        {
            System.out.println("ERROR : Connect to UniCommerce object failed");
            ex.printStackTrace(System.out);
        }
    }

    public static void main(String[] args)
    {
        parameter=args;
        try{UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());}
        catch(Exception e){e.printStackTrace();}
        new UniClient();
    }
}
