package Server;

import CampusInfo.*;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;

import java.net.*;
import java.sql.*;
import java.util.*;
import com.uwin.tds.*;
import javax.swing.UIManager;
import java.awt.*;

public class UniServer
{
    public static String[] parameter;
    public ServerFrame frame;
    public Connection conn;
    public Statement stmt;
    public String query;
    public String url_1="jdbc:uwindae:";
    public String url_2=":1433";
    public String user="guest";
    public String password="guest";

    private boolean packFrame = false;

    public UniServer()
    {
        frame = new ServerFrame(this);
        if (packFrame)
        {
            frame.pack();
        }
        else
        {
            frame.validate();
        }

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);

        initORB();
    }

    public void initORB()
    {
        try
        {
            ORB orb = ORB.init(parameter, null);
            POA rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
            rootpoa.the_POAManager().activate();

            UniCommerceImpl uniCommerceImpl = new UniCommerceImpl(this);
            org.omg.CORBA.Object ref = rootpoa.servant_to_reference(uniCommerceImpl);
            UniCommerce href = UniCommerceHelper.narrow(ref);
            org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
            NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

            String name = "UniCommerce";
            NameComponent path[] = ncRef.to_name(name);
            ncRef.rebind(path, href);

            frame.output("INFO","Server","Initialize ORB Successfully");

            orb.run();
        }

        catch (Exception ex)
        {
            frame.output("ERRO","Server","Initialize ORB failed");
            ex.printStackTrace(System.out);
        }
    }

    public void connectDB(String host)
    {
        try
        {
            Class.forName("com.uwin.tds.TdsDriver").newInstance();
            conn = DriverManager.getConnection(url_1+host+url_2, user, password);
            stmt=conn.createStatement ();

            frame.output("INFO","Server","Connect to SQL Successfully");
        }
        catch(Exception ex)
        {
            frame.output("ERRO","Server","Connect to SQL failed");
            ex.printStackTrace(System.out);
        }
    }

    public void disconnectDB()
    {
        try
        {
            stmt.close();
            conn.close();

            frame.output("INFO","Server","Disconnect to SQL Successfully");
        }
        catch(Exception ex)
        {
            frame.output("ERRO","Server","Disconnect to SQL failed");
            ex.printStackTrace(System.out);
        }
    }

    public static void main(String[] args)
    {
        parameter=args;

        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }

        catch(Exception e)
        {
            e.printStackTrace();
        }
        new UniServer();
    }
}